// common.h
//
// Created 1998 by Karri-Pekka Laakso
//
// $Id: common.h,v 1.2 1998/08/31 20:00:53 jks Exp $
//

#ifndef COMMON_H
#define COMMON_H

#include <stdio.h>


#define ASSERT(x) { if (!(x)) { printf("Internal error: file '%s', line %d\n", __FILE__, __LINE__); exit(1); } }

#define TRACE(x) { x };


//----------------------------------------
// Debug
//----------------------------------------

/** @name The debugging routines */
//@{

/** Sets the debug flags according to the command line.
    @param flags The debug flags to be enabled. */
extern void debugInit(char* flags);

/** Tests, if the given debug flag is enabled.
    @param flag The debug flag.
    @return true if the flag is enabled */
extern bool debugIsEnabled(char flag);

/** Prints a debug message if the given debug flag is enabled.
    @param flag The debug flag.
    @param format The debug message format like in printf().
    @param ... The variable list of arguments for the print format. */
extern void DEBUG (char flag, char* format, ...);
//@}

#endif // COMMON_H

//-----------------------------//
// Local Variables:            //
// mode: c++                   //
// make-backup-files: t        //
// End:                        //
//-----------------------------//

