// environment.cc
//
// Created 1998 by Jouni K Seppnen
//
// $Id: environment.cc,v 1.5 1999/08/09 12:29:45 jks Exp $
//

#include "environment.h"
#include <stdlib.h>
#include <string.h>

#ifndef BASSIST_LIBRARY
#error "BASSIST_LIBRARY undefined. Did you run configure and make?"
#endif

#ifndef BASSIST_INCLUDE_DIR
#error "BASSIST_INCLUDE_DIR undefined. Did you run configure and make?"
#endif

#ifndef BASSIST_TEMPLATE_DIR
#error "BASSIST_TEMPLATE_DIR undefined. Did you run configure and make?"
#endif

const string
environment::names[ENV_N_VAR] = {
    "BASSIST_LIBRARY",
    "BASSIST_INCLUDE_DIR",
    "BASSIST_TEMPLATE_DIR"
};

const string
environment::defaults[ENV_N_VAR] = {
    BASSIST_LIBRARY,
    BASSIST_INCLUDE_DIR,
    BASSIST_TEMPLATE_DIR
};

environment::environment()
{
    for (enum env_var i = static_cast<env_var>(0); 
	 i < ENV_N_VAR; i = static_cast<env_var>(i+1)) {
	char *s = getenv(names[i].c_str());
	if (s != 0 && strlen(s) > 0) {
	    values[i] = new string(s);
	} else {
	    values[i] = new string(defaults[i]);
	}
    }
}

environment::~environment()
{
    for (enum env_var i = static_cast<env_var>(0); 
	 i < ENV_N_VAR; i = static_cast<env_var>(i+1)) 
	{
	    delete values[i];
	}
}


// Local Variables:
// mode: c++
// make-backup-files: t
// c-basic-offset: 4
// End:
