#! /bin/sh

# genman.sh - does replacements in the Bassist manual pages
# $Id: genman.sh,v 1.2 1999/06/15 09:14:58 jks Exp $

# Usage:
# genman.sh called_from_Makefile <manpage.1.in >manpage.1
# Set environment variables BASSIST_VERSION, BASSIST_LIBRARY, 
# BASSIST_INCLUDE_DIR, BASSIST_TEMPLATE_DIR

if [ $# -ne 1 -o "$1" != called_from_Makefile ]; then
    echo "The script `basename $0` is not for interactive use." 1>&2
    exit 1
fi

TMP=/tmp/genman.sh.$$
trap "rm $TMP* 2>/dev/null" 0

# Replace @VARIABLE@s
cat >$TMP <<EOF
s%@BASSIST_VERSION@%${BASSIST_VERSION}%g
s%@BASSIST_LIBRARY@%${BASSIST_LIBRARY}%g
s%@BASSIST_INCLUDE_DIR@%${BASSIST_INCLUDE_DIR}%g
s%@BASSIST_TEMPLATE_DIR@%${BASSIST_TEMPLATE_DIR}%g
EOF

# Replace CVS dates with ISO 8601 compatible ones
# CVS outputs YYYY/MM/DD hh:mm:ss in UTC time, so the
# transformation is really simple.
cat >>$TMP <<'EOF'
s%@CVSDATE$\Date: \([0-9]\{4\}\)/\([0-9]\{2\}\)/\([0-9]\{2\}\) \([0-9:]\{8\}\) $@%\1-\2-\3T\4Z%g
s%@CVSDATE[^@]*@%unstuck in time%g
EOF

sed -f $TMP
