// constant.cc
//
// Created 1997 by Karri-Pekka Laakso
//
// $Id: constant.cc,v 1.3 1999/05/07 08:35:31 jks Exp $

#include "constant.h"
#include <stdio.h>


//---------------------------------------------------------------------
// constant::initialize
//
// --------------------------------------------------------------------

void
constant::initialize()
{
    if (! valueSet) {
	fprintf(stderr, "Error: the value of the constant %s is undefined\n",
		name.c_str());
	exit(1);
    }
}



//----------------------------------------------------------------------
// constant::askValue
//  Assigns this constant a value, if the string "name = value" is
//  found from the input.
//
// The value is of type double. Returns true if the sequence was
// found, false if it was not found.
// --------------------------------------------------------------------

bool
constant::askValue(scanner &sc, const char *n, bool init)
{
    // Get the next identifier, but don't move input, in case it
    // wasn't the one we're looking for
    char *nextId = sc.next(false);

    if (n == 0)
	n = name.c_str();
    
    if (nextId != 0 && strcmp(n, nextId) == 0) {
	// It matched, so first eat the id name
	sc.next();
	sc.get("=");
	if ( !init)
	    // Initial value for a constant is actually an error, but it's
	    // nicer to just skip the "i".
	    sc.ask("i"); 
	currentValue = sc.getDoubleValue();
	valueSet = true;
	return true;
    }

    return false;
}


//////////////////////////////////////////////////
// Local Variables:				//
// mode: c++					//
// make-backup-files: t				//
// End:						//
//////////////////////////////////////////////////
