// genReadData.cc
//
// Created 1998 by Karri-Pekka Laakso
//
// $Id: genReadData.cc,v 1.3 1998/10/17 08:01:41 jks Exp $
//

#include "genReadData.h"
#include "common.h"
#include "genGlobals.h"
#include "genRecords.h"


//---------------------------------------------------------------------
// readInput
//  Read data or initial values from file
// 
// --------------------------------------------------------------------

void
readInput(char *file, bool init) {
    DEBUG('s', "# Input file is %s\n", file);

    scanner sc(file);

    while(!sc.eof()) {
// All the read functions for generated records + the global read function

	if (sc.ask(",")
// FOREACH REC (RECORD)
	    || record_$REC.NAME::readInput(sc, init)
// ENDFOR
	    || globalReadInput(sc, init)) {
	  // ok, do nothing
	} else {
	    if (!sc.eof()) {
		fprintf(stderr, "Error in %s:%d: unknown input \"%s\"\n",
		        file, sc.line(), sc.next());
		exit(1);
	    }
	}
    }
    
    DEBUG('s', "# Input loaded\n");
}


//---------------------------------------------------------------------
// globalReadInput
//  Try to read global variable values from file
// 
// --------------------------------------------------------------------

bool
globalReadInput(scanner &sc, bool init) {
    char *s;
    constant *c;
    parameter *p;
    
    if (!(s = sc.next(false)))
	return false;

    p = (parameter *) globalParameters->get(s);
    if (p != 0) 
	return p->askValue(sc, 0, init);  // This should always be true

    c = (constant *) globalConstants->get(s);
    if (c != 0) 
	return c->askValue(sc, 0, init);  // This should always be true
    
    return false;
}


//-----------------------------//
// Local Variables:            //
// mode: c++                   //
// make-backup-files: t        //
// End:                        //
//-----------------------------//

